'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactJsonTree = require('react-json-tree');

var _reactJsonTree2 = _interopRequireDefault(_reactJsonTree);

var _ActionPreviewHeader = require('./ActionPreviewHeader');

var _ActionPreviewHeader2 = _interopRequireDefault(_ActionPreviewHeader);

var _JSONDiff = require('./JSONDiff');

var _JSONDiff2 = _interopRequireDefault(_JSONDiff);

var _immutable = require('immutable');

var _isIterable = require('./isIterable');

var _isIterable2 = _interopRequireDefault(_isIterable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var IS_IMMUTABLE_KEY = '@@__IS_IMMUTABLE__@@';

function isImmutable(value) {
  return _immutable.Iterable.isKeyed(value) || _immutable.Iterable.isIndexed(value) || _immutable.Iterable.isIterable(value);
}

function _getItemString(createTheme, type, data) {
  var text = void 0;

  function getShortTypeString(val) {
    if ((0, _isIterable2.default)(val) && !isImmutable(val)) {
      return '(…)';
    } else if (Array.isArray(val)) {
      return val.length > 0 ? '[…]' : '[]';
    } else if (val === null) {
      return 'null';
    } else if (val === undefined) {
      return 'undef';
    } else if ((typeof val === 'undefined' ? 'undefined' : (0, _typeof3.default)(val)) === 'object') {
      return (0, _keys2.default)(val).length > 0 ? '{…}' : '{}';
    } else if (typeof val === 'function') {
      return 'fn';
    } else if (typeof val === 'string') {
      return '"' + (val.substr(0, 10) + (val.length > 10 ? '…' : '')) + '"';
    } else if ((typeof val === 'undefined' ? 'undefined' : (0, _typeof3.default)(val)) === 'symbol') {
      return 'symbol';
    } else {
      return val;
    }
  }

  if (type === 'Object') {
    var keys = (0, _keys2.default)(data);
    var str = keys.slice(0, 2).map(function (key) {
      return key + ': ' + getShortTypeString(data[key]);
    }).concat(keys.length > 2 ? ['…'] : []).join(', ');

    text = '{ ' + str + ' }';
  } else if (type === 'Array') {
    var _str = data.slice(0, 2).map(getShortTypeString).concat(data.length > 2 ? ['…'] : []).join(', ');

    text = '[' + _str + ']';
  } else {
    text = type;
  }

  var immutableStr = data[IS_IMMUTABLE_KEY] ? 'Immutable' : '';

  return _react2.default.createElement(
    'span',
    createTheme('treeItemHint'),
    ' ',
    immutableStr,
    ' ',
    text
  );
}

var ActionPreview = function (_Component) {
  (0, _inherits3.default)(ActionPreview, _Component);

  function ActionPreview() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, ActionPreview);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_Object$getPrototypeO = (0, _getPrototypeOf2.default)(ActionPreview)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.labelRenderer = function (key) {
      for (var _len2 = arguments.length, rest = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        rest[_key2 - 1] = arguments[_key2];
      }

      var _this$props = _this.props;
      var styling = _this$props.styling;
      var onInspectPath = _this$props.onInspectPath;
      var inspectedPath = _this$props.inspectedPath;


      return _react2.default.createElement(
        'span',
        null,
        _react2.default.createElement(
          'span',
          styling('treeItemKey'),
          key
        ),
        _react2.default.createElement(
          'span',
          (0, _extends3.default)({}, styling('treeItemPin'), {
            onClick: function onClick() {
              return onInspectPath([].concat((0, _toConsumableArray3.default)(inspectedPath.slice(0, inspectedPath.length - 1)), (0, _toConsumableArray3.default)([key].concat(rest).reverse())));
            } }),
          '(pin)'
        )
      );
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(ActionPreview, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var styling = _props.styling;
      var delta = _props.delta;
      var error = _props.error;
      var nextState = _props.nextState;
      var onInspectPath = _props.onInspectPath;
      var inspectedPath = _props.inspectedPath;
      var tab = _props.tab;
      var onSelectTab = _props.onSelectTab;
      var action = _props.action;
      var base16Theme = _props.base16Theme;
      var isLightTheme = _props.isLightTheme;


      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({ key: 'actionPreview' }, styling('actionPreview')),
        _react2.default.createElement(_ActionPreviewHeader2.default, {
          styling: styling, inspectedPath: inspectedPath, onInspectPath: onInspectPath, tab: tab, onSelectTab: onSelectTab
        }),
        tab === 'Diff' && !error && _react2.default.createElement(_JSONDiff2.default, (0, _extends3.default)({ labelRenderer: this.labelRenderer
        }, { delta: delta, styling: styling, base16Theme: base16Theme, isLightTheme: isLightTheme })),
        (tab === 'State' && nextState && !error || tab === 'Action') && _react2.default.createElement(_reactJsonTree2.default, { labelRenderer: this.labelRenderer,
          theme: {
            extend: base16Theme,
            nestedNodeItemString: function nestedNodeItemString(_ref, expanded) {
              var style = _ref.style;
              return {
                style: (0, _extends3.default)({}, style, {
                  display: expanded ? 'none' : 'inline'
                })
              };
            }
          },
          data: tab === 'Action' ? action : nextState,
          getItemString: function getItemString(type, data) {
            return _getItemString(styling, type, data);
          },
          isLightTheme: isLightTheme,
          hideRoot: true }),
        error && _react2.default.createElement(
          'div',
          styling('stateError'),
          error
        )
      );
    }
  }]);
  return ActionPreview;
}(_react.Component);

exports.default = ActionPreview;